; Bottom_Line/theme.jl

(let*
  (
    (font (get-font "-adobe-helvetica-medium-r-normal-*-10-*-*-*-p-*-iso8859-1"))
    (font-colors (list "black"
                       "black"))
    
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
        (max 0 (+ 20 (min (- w-width 58) (text-width (window-name w) font)))))))
          
    (update-title-width
      (lambda (w)
        (if (eq (window-get w 'current-frame-style) 'Bottom_Line) 
          (rebuild-frame w))))
    
    (title-images (list (make-image "mid-title-inactive.png")
                        (make-image "mid-title-active.png")))
    (close-images (list (make-image "close-inactive.png") 
                        (make-image "close-active.png")))
    (maximize-images (list (make-image "maximize-inactive.png")
                           (make-image "maximize-active.png")))
    (bottom-image (make-image "bottom-bar.png"))
    (top-image (make-image "top-bar.png"))
    (top-left-image (make-image "top-left.png"))
    (top-right-image (make-image "top-right.png"))
    (bottom-left-image (make-image "bottom-left.png"))
    (bottom-right-image (make-image "bottom-right.png"))
    (left-image (make-image "left-bar.png"))
    (right-image (make-image "right-bar.png"))
    (black-dot-image (make-image "black-dot.png"))

    (frame `(
        ((background . ,black-dot-image) ; top edge
         (top-edge . -1)
         (left-edge . -1)
         (right-edge . -1)
         (class . top-border))
        ((background . ,black-dot-image) ; left edge
         (left-edge . -1)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
;        ((background . ,top-left-image)
;         (left-edge . -5)
;         (top-edge . -5)
;         (class . title))
;        ((background . ,top-right-image)
;         (right-edge . -5)
;         (top-edge . -5)
;         (class . title))
        ((background . ,black-dot-image) ; right edge
         (right-edge . -1)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))
        ((background . ,black-dot-image) ; bottom edge
         (right-edge . -1)
         (bottom-edge . -1)
         (left-edge . -1)
         (class . bottom-border))
        ((background . ,bottom-image) ; bottom resize button
         (left-edge . ,(lambda (w) (- (/ (+ (+ 32 (title-width w))
                                            (car (window-dimensions w)))
                                         2)
                                      10)))
         (bottom-edge . -6)
         (class . bottom-border))
        ((background . ,bottom-right-image) ; bottom-right resize button
         (right-edge . 0)
         (bottom-edge . -6)
         (class . bottom-right-corner))
;        ((background . ,bottom-left-image)
;         (left-edge . -5)
;         (bottom-edge . -5)
;         (class . bottom-left-corner))
        ((background . ,title-images)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (bottom-edge . -17)
         (left-edge . 16)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . center)
         (class . title))
        ((background . ,close-images)
         (left-edge . 0)
         (bottom-edge . -17)
         (class . close-button))
        ((background . ,maximize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 16)))
         (bottom-edge . -17)
         (class . maximize-button))
      ))
    (shaped-frame `(
        ((background . ,title-images)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (bottom-edge . -17)
         (left-edge . 16)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . center)
         (class . title))
        ((background . ,close-images)
         (left-edge . 0)
         (bottom-edge . -17)
         (class . close-button))
        ((background . ,maximize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 16)))
         (bottom-edge . -17)
         (class . maximize-button))
      ))
    )

  (add-frame-style 'Bottom_Line
    (lambda (w type)
      (cond 
            ((eq type 'shaped) shaped-frame)
            ((eq type 'unframed) nil-frame)
            (t frame))))
            
  (call-after-property-changed 'WM_NAME update-title-width)
)
